function init() {
    if ( window.widget ) {
        loadLOTO();
        _startReloadTimer();
    } else {
        test();
    }

    for ( var i = 0; i < 12; i++ ) {
        ( new Image() ).src = "Images/Wait" + i + ".png";
    }
}

var logging = true;//false;
function debug( message ) {
    if ( message == null || logging == false ) {
        return;
    }
    if ( window.Logger ) {
        Logger.log( message.toString() );
    } else {
        var elem = document.getElementById( "debug" );
        if ( elem == null ) {
            elem = document.createElement( "div" );
            elem.setAttribute( "id", "debug" );
            elem.setAttribute( "style", "position:absolute;left:0px;bottom:0px;width:100%;height:300px;font-size:10px;font-family:monospace;background:gray;color:black;" );
            document.firstChild.appendChild( elem );
        }
        elem.appendChild( document.createTextNode( message.toString() ) );
        elem.appendChild( document.createElement( "br" ) );
    }
}

var lotoData = null;
var pyCommand = null;

/// execute Python script
function loadLOTO() {
    if ( pyCommand ) {
        pyCommand.cancel();
        pyCommand = null;
    }
    if ( window.widget ) {
        _startTimer();
        pyCommand = widget.system( "/usr/bin/python Scripts/getlotodata.py", loadHandler );
        debug( "running command" );
    }
}

// this is prepared for debugging in Safari
function test() {
    var output = "-----LOTO6<http://www.takarakuji.mizuhobank.co.jp/miniloto/lt6-h1710.html>\n"
        +"T:261;D:H17.10.20;N:6,17,18,21,35,41;B:32;A:54815100/6,10962900/27,527700/673,10100/30809,1000/508889;C:0;S:4005131200\n"
        +"T:260;D:H17.10.13;N:11,15,21,31,37,41;B:30;A:34541200/9,9326000/30,228500/1469,6200/47666,1000/502569;C:0;S:3833610400\n"
        +"T:259;D:H17.10..6;N:1,12,15,23,34,42;B:27;A:22911800/21,4595500/75,221500/1867,8300/43748,1000/496807;C:0;S:4450853600\n"
        +"//------\n"
        +"-----MiniLOTO<http://www.takarakuji.mizuhobank.co.jp/miniloto/loto-h1710.html>\n"
        +"T:326;D:H17.10.18;N:1,3,6,11,25;B:12;A:14347500/20,115100/179,11500/3082,1000/86206;C:0;S:970578600\n"
        +"T:325;D:H17.10.11;N:8,11,13,15,28;B:22;A:9407400/29,83400/235,7900/4247,800/108127;C:0;S:922764800\n"
        +"T:324;D:H17.10.4;N:5,6,13,29,30;B:17;A:7569100/37,101600/198,10200/3391,1000/89475;C:0;S:947266000\n"
        +"//------\n"
        +"-----NUMBERS3<http://www.takarakuji.mizuhobank.co.jp/numbers/num3-h1710.html>\n"
        +"T:1679;D:H17.10.21;N:650;A:133100/79,22100/444,77600/164,11000/946,13300/448;C:0;S:110126600\n"
        +"T:1678;D:H17.10.20;N:775;A:108700/143,36200/224,72400/179,18100/298,10800/377;C:0;S:102569000\n"
        +"T:1677;D:H17.10.19;N:288;A:96800/91,32200/310,64500/177,16100/458,9600/996;C:0;S:105119000\n"
        +"//------\n"
        +"-----NUMBERS4<http://www.takarakuji.mizuhobank.co.jp/numbers/num4-h1710.html>\n"
        +"T:1679;D:H17.10.21;N:4044;A:1158300/43,289500/69,723900/77,144700/245;C:0;S:357786000\n"
        +"T:1678;D:H17.10.20;N:1717;A:489100/122,81500/118,285300/208,40700/527;C:0;S:333621000\n"
        +"T:1677;D:H17.10.19;N:1910;A:502800/64,41900/634,272300/140,20900/2789;C:0;S:345133600\n"
        +"//------\n";
    parseData( output );
}

// handle script result
function loadHandler( command ) {
    debug( "accepted" );
    if ( command.errorString ) {
        debug( "ERROR " + command.errorString );
        _stopTimer();
        return;
    }
    parseData( command.outputString );
    _stopTimer();
    pyCommand = null;
}

// interprete python output
function parseData( outputString ) {
    lotoData = new Array();
    var data = outputString.split( /\/\/\-+\n*/ );
    var re_title = new RegExp( "\\-*([^<]+)<([^>]+)>" );
    for ( var i = 0; i < data.length; i++ ) {
        var lines = data[ i ].split( "\n" );
        if ( lines.length > 0 ) {
            var m = re_title.exec( lines[ 0 ] );
            if ( m == null ) continue;
            var info = new LOTOInformation( m[ 1 ], m[ 2 ] );
            for ( var j = 1; j < lines.length; j++ ) {
                var items = lines[ j ].split( ";" );
                //debug( lines[ j ] );
                if ( items.length > 1 ) {
                    var result = new LOTOResult();
                    info.data.push( result );
                    for ( var k = 0; k < items.length; k++ ) {
                        var item = items[ k ].split( ":" );
                        var label = item[ 0 ];
                        var value = item[ 1 ];
                        //debug( label + " = " + value );
                        if ( label == "T" ) {
                            result.title = parseInt( value );
                        } else if ( label == "D" ) {
                            result.date = value;
                        } else if ( label == "C" ) {
                            result.carryover = parseInt( value );
                        } else if ( label == "S" ) {
                            result.totalSales = parseInt( value );
                        } else if ( label == "N" ) {
                            var nums = value.split( "," );
                            for ( var l = 0; l < nums.length; l++ ) {
                                nums[ l ] = nums[ l ];//parseInt( nums[ l ] );
                            }
                            result.numbers = nums;
                        } else if ( label == "B" ) {
                            result.bonus = value;//parseInt( value );
                        } else if ( label == "A" ) {
                            var nums = value.split( "," );
                            var awards = new Array();
                            for ( var l = 0; l < nums.length; l++ ) {
                                var an = nums[ l ].split( "/" );
                                awards.push( new Array( parseInt( an[ 0 ] ), parseInt( an[ 1 ] ) ) );
                            }
                            result.awards = awards;
                        }
                    }
                    //debug( result );
                }
            }

            // append information if it is available
            if ( info.data.length > 0 ) {
                lotoData.push( info );
            }
        }
        
    }

    // create tables
    refreshTables();
}

// make tables
function refreshTables() {
    if ( lotoData == null ) return;

    // recent data
    var table = document.getElementById( "recentResultTable" );
    while ( table.lastChild ) table.removeChild( table.lastChild );
    for ( var i = 0; i < lotoData.length; i++ ) {
        var caption = _createItem( lotoData[ i ].name, "div", "lotoclass" );
        caption.setAttribute( "onclick", "transit(event,'" + lotoData[ i ].name + "')" );
        var arrow = document.createElement( "img" );
        arrow.src = "Images/Arrow1.png";
        arrow.setAttribute( "style", "right:0px;padding-left:32px;width:10px;height:10px;padding-top:2px;" );
        arrow.style.right = "0px";
        caption.appendChild( arrow );
        arrow.setAttribute( "onclick", "debug('clicked');widget.openURL('" + lotoData[ i ].url + "');" );

        table.appendChild( caption );
        var result = lotoData[ i ].getRecentResult();
        if ( result == null ) continue;
        var elem = result.formatSimpleRow();
        elem.setAttribute( "onclick", "transit(event,'" + lotoData[ i ].name + "')" );
        table.appendChild( elem );
    }
    var bonusexp = document.createElement( "div" );
    bonusexp.setAttribute( "class", "explanation" );
    bonusexp.innerText = "* ボーナス数字";
    table.appendChild( bonusexp );

    // for each LOTO class
    for ( var i = 0; i < lotoData.length; i++ ) {
        var data = lotoData[ i ];
        //debug( data.name );
        var lt = null;
        if ( data.name == "LOTO6" ) {
            lt = document.getElementById( "LOTO6" );
        } else if ( data.name == "MiniLOTO" ) {
            lt = document.getElementById( "MiniLOTO" );
        } else if ( data.name == "NUMBERS3" ) {
            lt = document.getElementById( "NUMBERS3" );
        } else if ( data.name == "NUMBERS4" ) {
            lt = document.getElementById( "NUMBERS4" );
        }
        if ( lt ) {
            while ( lt.firstChild ) lt.removeChild( lt.firstChild );
            data.createTable( lt );
        }
    }
}

//
// LOTO information for a LOTO class
//
function LOTOInformation( name, url ) {
    this.name = name;
    this.url = url;
    this.data = new Array();
    this.toString = function() {
        var output = this.name + " : " + this.url + "\n";
        for ( var i = 0; i < this.data.length; i++ ) {
            output += this.data[ i ].toString() + "\n";
        }
        return output;
    }
    this.getRecentResult = function() {
        if ( this.data.length == 0 ) { return null; }
        return this.data[ 0 ];
    }
}

LOTOInformation.prototype.createTable = function( elem ) {
    elem.setAttribute( "onclick", "disapper(event,this);" );
    var astr;
    if ( this.name == "LOTO6" || this.name == "MiniLOTO" ) {
        astr = [ "１等", "２等", "３等", "４等", "５等", "６等"];
    } else {
        astr = [ "ストレート", "ボックス", "Ｓストレート", "Ｓボックス", "ミニ" ];
    }
    for ( var i = 0; i < this.data.length; i++ ) {
        elem.appendChild( this.data[ i ].formatRow( astr ) );
    }
}

//
// LOTO result of one draw
//
function LOTOResult() {
    this.title = "";
    this.date = "";
    this.numbers = "";
    this.bonus = null;
    this.awards = new Array();
    this.carryover = 0;
    this.totalSales = 0;
    this.toString = function() {
        var output = this.title + " " + this.date + "\n";
        output += "NUMBERS : ";
        for ( var i = 0; i < this.numbers.length; i++ ) {
            output += this.numbers[ i ] + " ";
        }
        if ( this.bonus != null ) {
            output += " BONUS : " + this.bonus;
        }
        output += "\nAWARDS : ";
        for ( var i = 0; i < this.awards.length; i++ ) {
            output += this.awards[ i ][ 0 ] + "-" + this.awards[ i ][ 1 ] + " ";
        }
        output += "\nCO : " + this.carryover + "\nSALES : " + this.totalSales;
        return output;
    }
}

// simple element maker
function _createItem( data, qname, cname ) {
    if ( qname == null ) qname = "span";
    var elem = document.createElement( qname );
    if ( cname ) {
        elem.setAttribute( "class", cname );
    }
    elem.appendChild( document.createTextNode( data ) );
    return elem;
}

// format figures
function _formatFigures( money ) {
    var nstr = "" + money;
    var size = nstr.length;
    var output = "";
    for ( var i = 3; i < size; i+= 3 ) {
        output = "," + nstr.substring( size - i, size - i + 3 ) + output;
    }
    var end = size % 3;
    if ( end == 0 ) end = 3;
    output = nstr.substring( 0, end ) + output;
    return output;
}

LOTOResult.prototype.formatRow = function( awardRankStrings) {
    // create detailed information division
    var elem = document.createElement( "div" );
    elem.setAttribute( "class", "detail" );

    // use simpler version as a header
    var elem_title = this.formatSimpleRow( true );
    elem_title.setAttribute( "class", "result-short" );
    elem.appendChild( elem_title );

    // reward information
    var elem_ret  = document.createElement( "div" );
    elem_ret.setAttribute( "class", "return" );
    for ( var i = 0; i < this.awards.length; i++ ) {
        var money = _formatFigures( this.awards[ i ][ 0 ] ) + "円";
        var lots  = _formatFigures( this.awards[ i ][ 1 ] ) + "口";
        var item  = document.createElement( "div" );
        item.setAttribute( "class", "award" );
        var astr = "";
        item.appendChild( document.createTextNode( awardRankStrings[ i ] ) );
        item.appendChild( document.createElement( "br" ) );
        item.appendChild( document.createTextNode( money ) );
        item.appendChild( document.createElement( "br" ) );
        item.appendChild( document.createTextNode( lots ) );
        elem_ret.appendChild( item );
    }
    elem.appendChild( elem_ret );

    var elem_info = document.createElement( "div" );
    elem_info.setAttribute( "class", "info" );
    elem.appendChild( elem_info );

    // total sales
    var elem_sales = document.createElement( "div" );
    elem_sales.setAttribute( "class", "sales" );
    elem_sales.appendChild( document.createTextNode( "総売上 " ) );
    elem_sales.appendChild( document.createTextNode( _formatFigures( this.totalSales ) + "円" ) );
    elem_info.appendChild( elem_sales );

    // append carry-over if exists
    if ( this.carryover > 0 ) {
        var elem_co = document.createElement( "div" );
        elem_co.setAttribute( "class", "carryover" );
        elem_co.appendChild( document.createTextNode( "キャリーオーバー " ) );
        elem_co.appendChild( document.createTextNode( _formatFigures( this.carryover ) + "円" ) );
        elem_info.appendChild( elem_co );
    }

    return elem;
}

LOTOResult.prototype.formatSimpleRow = function( flag_bonus ) {
    var elem = document.createElement( "div" );
    elem.setAttribute( "class", "result" );
    var nth;
    var rm10 = this.title % 10;
    var rm100 = this.title % 100;
    if ( rm10 == 1 && rm100 != 11 ) nth = this.title + "st";
    else if ( rm10 == 2 && rm100 != 12 ) nth = this.title + "nd";
    else if ( rm10 == 3 && rm100 != 13 ) nth = this.title + "rd";
    else nth = this.title + "th";
    
    elem.appendChild( _createItem( nth, "div", "order" ) );
    var dt = this.date.replace( new RegExp( "^[A-Z0-9]+\\." ), "" );
    elem.appendChild( _createItem( dt, "div", "date" ) );
    var nel = document.createElement( "span" );
    nel.setAttribute( "class", "numbers" );
    for ( var i = 0; i < this.numbers.length; i++ ) {
        nel.appendChild( _createItem( this.numbers[ i ], "span", "number" ) );
    }
    elem.appendChild( nel );
    if ( this.bonus ) {
        var bspan = _createItem( this.bonus, "span", "bonus" );
        if ( !flag_bonus ) {
            var bstar = _createItem( "*", "sup" );
            bspan.appendChild( bstar );
        }
        nel.appendChild( bspan );
    }
    return elem;
};


// Table transition
var trTimer = null;
var trTarget = null;
var trTarget2 = null;
var trCount = 0;
var trSteps = 10;
var trWait = 33;

function disapper( event, elem ) {
    if ( trTimer != null || lotoData == null ) return;
    trTarget = elem;
    trTarget2 = document.getElementById( "recentResultTable" );
    trTarget.style.display = "block";
    trTarget2.style.opacity = "0";
    trTarget2.style.display = "block";
    trCount = 0;
    trTimer = setInterval( _tickTransition, trWait );
    _tickTransition();
}

function transit( event, name ) {
    if ( trTimer != null || lotoData == null ) return;
    for ( var i = 0; i < lotoData.length; i++ ) {
        if ( name == lotoData[ i ].name ) {
            trTarget = document.getElementById( "recentResultTable" );
            trTarget2 = document.getElementById( name );
            if ( trTarget2 == null ) {
                var elem = document.createElement( "div" );
                elem.setAttribute( "class", "table" );
                elem.setAttribute( "id", lotoData[ i ].name );
                elem.appendChild( document.createTextNode( "NULL TABLE" ) );
                trTarget2 = elem;
                trTarget.parentNode.appendChild( elem );
            }
            trTimer = setInterval( _tickTransition, 66 );
            trTarget.style.display = "block";
            trTarget2.style.opacity = "0";
            trTarget2.style.display = "block";
            trCount = 0;
            _tickTransition();
            break;
        }
    }
}

function _tickTransition() {
    if ( trTarget != null && trTarget2 != null ) {
        trCount ++;
        var ratio = trCount / trSteps;
        if ( trCount >= trSteps ) {
            clearInterval( trTimer );
            trTimer = null;
            trTarget.style.opacity  = "0";
            trTarget2.style.opacity = "1";
            trTarget.style.zIndex   = "100";
            trTarget2.style.zIndex  = "101";
            return;
        }
        trTarget2.style.opacity = ratio;
        trTarget.style.opacity = 1.0 - ratio;
    } else {
        debug( "no element" );
        clearInterval( trTimer );
        trTimer = null;
    }
}

// wait rolly
var waitTimer = null;
var waitCount = 0;

function _startTimer() {
    if ( waitTimer ) _stopTimer();
    document.getElementById( "wait" ).style.display = "block";
    waitTimer = setInterval( _tickTimer, 66 );
    _tickTimer();
}
function _stopTimer() {
    if ( waitTimer ) {
        clearInterval( waitTimer );
        waitTimer = null;
        document.getElementById( "wait" ).style.display = "none";
    }
}
function _tickTimer() {
    if ( waitCount >= 12 ) waitCount = 0;
    document.getElementById( "wait" ).src = "Images/Wait" + waitCount + ".png";
    waitCount++;
}

// reload manager
var reloadTimer = null;
var reloadCount = 0;

function _startReloadTimer() {
    // check every 1 hour
    reloadTimer = setInterval( _tickReload, 1000 * 60 * 60  );
}

function _tickReload() {
    //debug( "RELOAD COUNT " + reloadCount );
    if ( ++reloadCount > 4 ) { // reload every 4 hours
        loadLOTO();
        reloadCount = 0;
    }
}
